<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for JP_RentacarLocationDetail StructType
 * @subpackage Structs
 */
class JP_RentacarLocationDetail extends AbstractStructBase
{
    /**
     * The Name
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Name;
    /**
     * The Zone
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_Zone
     */
    public $Zone;
    /**
     * The Address
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Address;
    /**
     * The Latitude
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Latitude;
    /**
     * The Longitude
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Longitude;
    /**
     * The PhoneNumbers
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfJP_PhoneNumber
     */
    public $PhoneNumbers;
    /**
     * The OperationSchedule
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_OperationSchedule
     */
    public $OperationSchedule;
    /**
     * The Supplier
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_Supplier
     */
    public $Supplier;
    /**
     * The Code
     * @var string
     */
    public $Code;
    /**
     * The Group
     * @var string
     */
    public $Group;
    /**
     * The LocationType
     * @var string
     */
    public $LocationType;
    /**
     * Constructor method for JP_RentacarLocationDetail
     * @uses JP_RentacarLocationDetail::setName()
     * @uses JP_RentacarLocationDetail::setZone()
     * @uses JP_RentacarLocationDetail::setAddress()
     * @uses JP_RentacarLocationDetail::setLatitude()
     * @uses JP_RentacarLocationDetail::setLongitude()
     * @uses JP_RentacarLocationDetail::setPhoneNumbers()
     * @uses JP_RentacarLocationDetail::setOperationSchedule()
     * @uses JP_RentacarLocationDetail::setSupplier()
     * @uses JP_RentacarLocationDetail::setCode()
     * @uses JP_RentacarLocationDetail::setGroup()
     * @uses JP_RentacarLocationDetail::setLocationType()
     * @param string $name
     * @param \StructType\JP_Zone $zone
     * @param string $address
     * @param string $latitude
     * @param string $longitude
     * @param \ArrayType\ArrayOfJP_PhoneNumber $phoneNumbers
     * @param \StructType\JP_OperationSchedule $operationSchedule
     * @param \StructType\JP_Supplier $supplier
     * @param string $code
     * @param string $group
     * @param string $locationType
     */
    public function __construct($name = null, \StructType\JP_Zone $zone = null, $address = null, $latitude = null, $longitude = null, \ArrayType\ArrayOfJP_PhoneNumber $phoneNumbers = null, \StructType\JP_OperationSchedule $operationSchedule = null, \StructType\JP_Supplier $supplier = null, $code = null, $group = null, $locationType = null)
    {
        $this
            ->setName($name)
            ->setZone($zone)
            ->setAddress($address)
            ->setLatitude($latitude)
            ->setLongitude($longitude)
            ->setPhoneNumbers($phoneNumbers)
            ->setOperationSchedule($operationSchedule)
            ->setSupplier($supplier)
            ->setCode($code)
            ->setGroup($group)
            ->setLocationType($locationType);
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \StructType\JP_RentacarLocationDetail
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get Zone value
     * @return \StructType\JP_Zone|null
     */
    public function getZone()
    {
        return $this->Zone;
    }
    /**
     * Set Zone value
     * @param \StructType\JP_Zone $zone
     * @return \StructType\JP_RentacarLocationDetail
     */
    public function setZone(\StructType\JP_Zone $zone = null)
    {
        $this->Zone = $zone;
        return $this;
    }
    /**
     * Get Address value
     * @return string|null
     */
    public function getAddress()
    {
        return $this->Address;
    }
    /**
     * Set Address value
     * @param string $address
     * @return \StructType\JP_RentacarLocationDetail
     */
    public function setAddress($address = null)
    {
        // validation for constraint: string
        if (!is_null($address) && !is_string($address)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($address)), __LINE__);
        }
        $this->Address = $address;
        return $this;
    }
    /**
     * Get Latitude value
     * @return string|null
     */
    public function getLatitude()
    {
        return $this->Latitude;
    }
    /**
     * Set Latitude value
     * @param string $latitude
     * @return \StructType\JP_RentacarLocationDetail
     */
    public function setLatitude($latitude = null)
    {
        // validation for constraint: string
        if (!is_null($latitude) && !is_string($latitude)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($latitude)), __LINE__);
        }
        $this->Latitude = $latitude;
        return $this;
    }
    /**
     * Get Longitude value
     * @return string|null
     */
    public function getLongitude()
    {
        return $this->Longitude;
    }
    /**
     * Set Longitude value
     * @param string $longitude
     * @return \StructType\JP_RentacarLocationDetail
     */
    public function setLongitude($longitude = null)
    {
        // validation for constraint: string
        if (!is_null($longitude) && !is_string($longitude)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($longitude)), __LINE__);
        }
        $this->Longitude = $longitude;
        return $this;
    }
    /**
     * Get PhoneNumbers value
     * @return \ArrayType\ArrayOfJP_PhoneNumber|null
     */
    public function getPhoneNumbers()
    {
        return $this->PhoneNumbers;
    }
    /**
     * Set PhoneNumbers value
     * @param \ArrayType\ArrayOfJP_PhoneNumber $phoneNumbers
     * @return \StructType\JP_RentacarLocationDetail
     */
    public function setPhoneNumbers(\ArrayType\ArrayOfJP_PhoneNumber $phoneNumbers = null)
    {
        $this->PhoneNumbers = $phoneNumbers;
        return $this;
    }
    /**
     * Get OperationSchedule value
     * @return \StructType\JP_OperationSchedule|null
     */
    public function getOperationSchedule()
    {
        return $this->OperationSchedule;
    }
    /**
     * Set OperationSchedule value
     * @param \StructType\JP_OperationSchedule $operationSchedule
     * @return \StructType\JP_RentacarLocationDetail
     */
    public function setOperationSchedule(\StructType\JP_OperationSchedule $operationSchedule = null)
    {
        $this->OperationSchedule = $operationSchedule;
        return $this;
    }
    /**
     * Get Supplier value
     * @return \StructType\JP_Supplier|null
     */
    public function getSupplier()
    {
        return $this->Supplier;
    }
    /**
     * Set Supplier value
     * @param \StructType\JP_Supplier $supplier
     * @return \StructType\JP_RentacarLocationDetail
     */
    public function setSupplier(\StructType\JP_Supplier $supplier = null)
    {
        $this->Supplier = $supplier;
        return $this;
    }
    /**
     * Get Code value
     * @return string|null
     */
    public function getCode()
    {
        return $this->Code;
    }
    /**
     * Set Code value
     * @param string $code
     * @return \StructType\JP_RentacarLocationDetail
     */
    public function setCode($code = null)
    {
        // validation for constraint: string
        if (!is_null($code) && !is_string($code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($code)), __LINE__);
        }
        $this->Code = $code;
        return $this;
    }
    /**
     * Get Group value
     * @return string|null
     */
    public function getGroup()
    {
        return $this->Group;
    }
    /**
     * Set Group value
     * @param string $group
     * @return \StructType\JP_RentacarLocationDetail
     */
    public function setGroup($group = null)
    {
        // validation for constraint: string
        if (!is_null($group) && !is_string($group)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($group)), __LINE__);
        }
        $this->Group = $group;
        return $this;
    }
    /**
     * Get LocationType value
     * @return string|null
     */
    public function getLocationType()
    {
        return $this->LocationType;
    }
    /**
     * Set LocationType value
     * @param string $locationType
     * @return \StructType\JP_RentacarLocationDetail
     */
    public function setLocationType($locationType = null)
    {
        // validation for constraint: string
        if (!is_null($locationType) && !is_string($locationType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($locationType)), __LINE__);
        }
        $this->LocationType = $locationType;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\JP_RentacarLocationDetail
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
